local function get_reagent()
	for reagentID, reagent in pairs(trackedReagent) do
		trackedReagent[reagentID] = GetItemCount(reagentID, true);
	end

	ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_PROFESSION);
end

local function get_tradeskills()
	local professionName = GetTradeSkillLine();

	if ( not trackedTradeSkill[professionName] ) then
		trackedTradeSkill[professionName] = {};
	end

	for skillIndex = 1, GetNumTradeSkills() do
		local skillCooldown, hasCooldown = GetTradeSkillCooldown(skillIndex);

		if ( hasCooldown ) then
			local skillLink = GetTradeSkillRecipeLink(skillIndex);
			local skillID = tonumber(string.match(skillLink, "|Henchant:(%d+)|"));
			local reagents, insert = {}, true;

			for reagentIndex = 1, GetTradeSkillNumReagents(skillIndex) do
				local reagentLink = GetTradeSkillReagentItemLink(skillIndex, reagentIndex);

				if ( reagentLink ) then
					local reagentID = tonumber(string.match(reagentLink, "|Hitem:(%d+):"));
					local reagentName, _, reagentCount, playerCount = GetTradeSkillReagentInfo(skillIndex, reagentIndex);

					reagents[reagentID] = {
						name	= reagentName,
						count	= reagentCount
					};

					trackedReagent[reagentID] = playerCount;
				else
					insert = false;
				end
			end

			if ( insert == true ) then
				trackedTradeSkill[professionName][skillID] = {
					name		= GetTradeSkillInfo(skillIndex),
					cooldown	= skillCooldown,
					reagents	= reagents,
					datetime	= time()
				};
			end
		end
	end

	ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_PROFESSION);
end

local objFrame = CreateFrame("Frame");

objFrame:RegisterEvent("BAG_UPDATE");
objFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
objFrame:RegisterEvent("TRADE_SKILL_SHOW");
objFrame:RegisterEvent("TRADE_SKILL_UPDATE");
objFrame:RegisterEvent("VARIABLES_LOADED");

objFrame:SetScript("OnEvent", function(self, event, ...)
	if ( event == "BAG_UPDATE" ) then
		get_reagent();
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		get_reagent();
	elseif ( event == "TRADE_SKILL_SHOW" ) then
		get_tradeskills();
	elseif ( event == "TRADE_SKILL_UPDATE" ) then
		get_tradeskills();
	elseif ( event == "VARIABLES_LOADED" ) then
		if ( not trackedCooldown ) then		trackedCooldown = {};	end
		if ( not trackedProfession ) then	trackedProfession = {};	end
		if ( not trackedReagent ) then		trackedReagent = {};	end
		if ( not trackedTradeSkill ) then	trackedTradeSkill = {};	end
	end
end);
